thetaobs=[1.9020    1.7097    1.1458    1.0989    6.2    6.1    5.3483    6.01    0.8781    1.1078    0.4171    0.4260    1.0524    1.3611    2.2927    0.666 1.0937    0.9588    0.0335    0.7805];
hold off
fprintf(1,'we start with the simple dataset used initially in the paper\n')
fprintf(1,'press a key  to plot the rose diagram of this data with 20 bins')
pause
rose(thetaobs,20);
set(gca,'View',[-90 90],'YDir','reverse');

%convert to rectangular coordinates
r=[cos(thetaobs); sin(thetaobs)];
fprintf(1,' rectangular mean')
Rbar=mean(r,2)
fprintf(1,'press a key \n')
pause
fprintf(1,'circular mean (polar coordinates radians):')
atan2(Rbar(2),Rbar(1))
fprintf(1,'press a key \n')
pause
fprintf(1,'circular mean (polar coordinates degrees):')
rad2deg(atan2(Rbar(2),Rbar(1)))
fprintf(1,'press a key \n')
pause
fprintf(1,'circular mean plotted\n')
hold on
compass(5*Rbar(2),5*Rbar(1),'r')
hold off
pause
fprintf(1,'the linear mean (degrees) is not useful:')
rad2deg(mean(thetaobs))
pause
fprintf(1,'linear mean plotted\n')
hold on
compass(5*cos(mean(thetaobs)),5*sin(mean(thetaobs)),'m')
hold off
fprintf(1,'press a key \n')
pause
fprintf(1,'circular variance:')
1-norm(Rbar)




%xlabel '\theta'
%ylabel 'frequency'
saveas(gca,'rosedataset1.png')

fprintf(1,'press a key to plot a histogram of the same data\n')
pause
hist(rad2deg(thetaobs),rad2deg(0:pi/8:2*pi))
axis([0 360 0 8])
xlabel '\theta'
ylabel 'frequency'
saveas(gca,'histdataset1.png')

fprintf(1,'Press a key to fit a von Mises distribution to the same data')
pause
[thetahat,kappahat]=circ_vmpar(thetaobs)
fprintf(1,'note that thetahat is the circular mean from before, but kappahat (or 1/kappahat is not the circular variance\n')
fprintf(1,'press a key to see the polar plot of the probability density function (pdf)\n')
pause

t=linspace(0,2*pi,100);
poftheta=circ_vmpdf(t,thetahat,kappahat);
polar(t,poftheta', 'b');
%xlabel '\theta'
%ylabel 'f_\theta'
set(gca,'View',[-90 90],'YDir','reverse');
fprintf(1,'press a key to see the same plot on regular axes\n')
saveas(gca,'polarpdfdataset1.png')
pause
plot(rad2deg(t),poftheta)
xlabel '\theta'
ylabel 'f_\theta'
set(gca,'xtick',[0:45:360])
saveas(gca,'linearpdfdataset1.png')
fprintf(1,'Now we will consider a new dataset with multiple modes. To see the new dataset press a key')
pause

thetaobs2=[1.5720    4.4378    4.0775    3.9905    4.5085    2.8684    4.4997    1.9532    3.8942    2.150   2.0609    3.6444    1.8194    4.3043    1.8152    4.0762    1.9241    4.1702    2.1667    4.2494];
    
rose(thetaobs2,20);
set(gca,'View',[-90 90],'YDir','reverse');
%xlabel '\theta'
%ylabel 'frequency'
saveas(gca,'rosedataset2.png')


fprintf(1,'\n\nNote the two modes.  Now we compute the same statistics as used at the start, but in this case the mean values do not work\n')
pause
r=[cos(thetaobs2); sin(thetaobs2)];
fprintf(1,'rectangular mean')
Rbar=mean(r,2)
fprintf(1,'press a key \n')
pause
fprintf(1,'circular mean (polar coordinates radians):')
atan2(Rbar(2),Rbar(1))
fprintf(1,'press a key \n')
pause
fprintf(1,'circular mean (polar coordinates degrees):')
thetahat=rad2deg(atan2(Rbar(2),Rbar(1)))
fprintf(1,'press a key \n')
pause
fprintf(1,'the linear mean (degrees) is not useful:')
rad2deg(mean(thetaobs2))
fprintf(1,'press a key \n')
pause
fprintf(1,'circular variance:')
1-norm(Rbar)

fprintf(1,'Similarly disappointing results occur when fitting a von Mises distribution.\n')
[thetahat,kappahat]=circ_vmpar(thetaobs2)
pause
fprintf(1,'press a key to see the plot of the pdf\n')

t=linspace(0,2*pi,100);
poftheta=circ_vmpdf(t,thetahat,kappahat);
polar(t,poftheta', 'b');
%xlabel '\theta'
%ylabel 'f_\theta'
set(gca,'View',[-90 90],'YDir','reverse');
saveas(gca,'polarpdfdataset2.png')

fprintf(1,'or we can plot the direction\n')
pause
compass(cos(thetahat),sin(thetahat),'r')
set(gca,'View',[-90 90],'YDir','reverse');
saveas(gca,'compassonecompdata2.png')


fprintf(1,'Instead we can fit a mixture of von Mises model with 2 components')
fprintf(1,'press a key to see the plot of the pdf\n')
pause
[mubark,kappabar,piv,thetahat]=emvm(thetaobs2,2);
p=mixvmpdf(t,mubark,kappabar,piv,thetahat);
polar(t,p)
%xlabel '\theta'
%ylabel 'f_\theta'
set(gca,'View',[-90 90],'YDir','reverse');
saveas(gca,'polarpdfdataset2mixvmtwo.png')


fprintf(1,'or we can plot the direction\n')
pause
compass(piv.*cos(thetahat),piv.*sin(thetahat),'r')
set(gca,'View',[-90 90],'YDir','reverse');
saveas(gca,'compasstwocompdata2.png')


fprintf(1,'See that this distribution, captures the modes much better\n')
fprintf(1,'Although it does not seem necessary it is also possible to use the mixture of von Mises with 3 components\n')
fprintf(1,'press a key to see the plot of the pdf\n')
pause
[mubark,kappabar,piv,thetahat]=emvm(thetaobs2,3);
p=mixvmpdf(t,mubark,kappabar,piv,thetahat);
polar(t,p)
set(gca,'View',[-90 90],'YDir','reverse');
%xlabel '\theta'
%ylabel 'f_\theta'
fprintf(1,'In this case it is hard to see the third mixture, because the underlying structure of the data has only two modes\n')
fprintf(1,'In general setting the number of components is a hard problem for mixture models and heuristics must be used\n')
fprintf(1,'press a key to continue\n')
saveas(gca,'polarpdfdataset2mixvmthree.png')

fprintf(1,'or we can plot the direction\n')
pause
compass(piv.*cos(thetahat),piv.*sin(thetahat),'r')
set(gca,'View',[-90 90],'YDir','reverse');
saveas(gca,'compassthreecompdata2.png')

pause
fprintf(1,'Another possible approach is to use parzens window as a non-paramteric density estimate\n using a von Mises distribution as the kernel\n')
fprintf(1,'press a key to see the pdf where kappa=20\n\n')

pause
kappa_ibw=20;
p=zeros(size(t));
for ii=1:size(thetaobs2,2)
    p=p+circ_vmpdf(t,thetaobs2(ii),kappa_ibw)';
end
p=p/size(thetaobs2,2);

polar(t,p);
%xlabel '\theta'
%ylabel 'f_\theta'
set(gca,'View',[-90 90],'YDir','reverse');

fprintf(1,'press a key to see the pdf where kappa=100\n\n')
saveas(gca,'polarpdfdataset2parzenkappa20.png')
pause

kappa_ibw=100;
p=zeros(size(t));
for ii=1:size(thetaobs2,2)
    p=p+circ_vmpdf(t,thetaobs2(ii),kappa_ibw)';
end
p=p/size(thetaobs2,2);

polar(t,p);
%xlabel '\theta'
%ylabel 'f_\theta'
set(gca,'View',[-90 90],'YDir','reverse');
saveas(gca,'polarpdfdataset2parzenkappa100.png')
fprintf(1,'Note that kappa is inversely related to the variance (often the root variance is called the bandwidth in this context)\n')
fprintf(1,'A large kappa value gives a more detailed estimate with less smoothing, but is also more vulnerable to noise\n')
fprintf(1,'In general it is hard to set the bandwidth and heuristics must be used\n')

pause

fprintf(1,'\n\nNow we will consider a different topic, testing the hypothesis that the two datasets are independent\n')
fprintf(1,'for the purpose of this exercise we will imagine that the first data set gives direction of travel of a \n')
fprintf(1,'passenger on the bus network where the second gives the direction to work of the same passenger\n')
fprintf(1,'a question of interest might be is it required to model the joint distribution f(theta1,theta2)\n')
fprintf(1,'or can the simplification f(theta1,theta2)=f(theta1)f(theta2), be made? A first simple\n')
fprintf(1,'approach might be to plot the bivariate data\n')
fprintf(1,'press a key to continue\n')
plot(thetaobs,thetaobs2,'o')
pause
fprintf(1,'it is hard to see a relationship here, but lets proceed with the test anyway')
fprintf(1,'press a key to estimate this density with a bivariate von Mises kernel')
pause
fprintf(1,'a bivariate kernel density estimate, kappa=20\n')
pause
[t1,t2]=meshgrid(0:0.01:2*pi,0:0.01:2*pi);
kappa_ibw=100;
p=zeros(size(t));
for ii=1:size(thetaobs2,2)
    p=p+circ_vmpdf(t,thetaobs2(ii),kappa_ibw)';
end

fprintf(1,'alternatively we can assume independence and then make the bivariate density the product of two independent estimates\n')


kappa_ibw=20;
[t1,t2]=meshgrid(0:0.1:2*pi,0:0.1:2*pi);
p12=zeros(size(t1));
for ii=1:size(thetaobs,2)
    p12=p12+circ_vmpdf2d(t1,t2,[thetaobs(ii) thetaobs2(ii)],kappa_ibw);
end
p12=p12/size(thetaobs2,2);
pcolor(t1,t2,p12);
xlabel '\theta_1'
ylabel '\theta_2'
fprintf(1,'bivariate estimate f(theta1,theta2)\n')

pause

t1o=[0:0.1:2*pi];
p1 = zeros(size(t1o));
for ii=1:size(thetaobs,2)
    p1=p1+circ_vmpdf(t1o,thetaobs(ii),kappa_ibw)';
end

t2o=[0:0.1:2*pi];
p2 = zeros(size(t1o));
for ii=1:size(thetaobs,2)
    p2=p2+circ_vmpdf(t2o,thetaobs2(ii),kappa_ibw)';
end


pcolor(t1,t2,p2'*p1)
xlabel '\theta_1'
ylabel '\theta_2'
fprintf(1,'product of univariate estimates f(theta1)f(theta2)\n')
pause
fprintf(1,'which is made up of the following univariate densities (press a key)')
plot(t1o,p1)
xlabel 'f_{\theta_1}'
pause
fprintf(1,'\nand\n')

plot(t1o,p2)
xlabel '\theta_2'
fprintf(1,'')
pause

t2o=[0:0.1:2*pi];

fprintf(1,'the empirical mutual information based upon the above estimates is computed as')

T=sum(log(eval_kernsmothtwod(thetaobs,thetaobs2,thetaobs,thetaobs2,kappa_ibw))) - sum(log(eval_kernsmoth(thetaobs,thetaobs,kappa_ibw).*eval_kernsmoth(thetaobs2,thetaobs,kappa_ibw)))

Nstrap=4000;
bootstrap=zeros(1,Nstrap);
for ii=1:Nstrap
    thetaobsstrap = thetaobs(randi(size(thetaobs,2),size(thetaobs)));
    thetaobsstrap2 = thetaobs2(randi(size(thetaobs,2),size(thetaobs)));
    bootstrap(ii)=sum(log(eval_kernsmothtwod(thetaobsstrap,thetaobsstrap2,thetaobsstrap,thetaobsstrap2,kappa_ibw))) - sum(log(eval_kernsmoth(thetaobsstrap,thetaobsstrap,kappa_ibw).*eval_kernsmoth(thetaobsstrap2,thetaobsstrap,kappa_ibw)));
end
hist(bootstrap,100)
xlabel 'T(.)'
ylabel 'frequency'
saveas(gca,'samplingdisttheta1theta2.png')
fprintf(1,'p-value is')
sum(bootstrap>T)/Nstrap

pause

fprintf(1,'for comparison it might be a good idea to run the test where theta1=theta2')
thetaobs2=thetaobs;
pause
T=sum(log(eval_kernsmothtwod(thetaobs,thetaobs2,thetaobs,thetaobs2,kappa_ibw))) - sum(log(eval_kernsmoth(thetaobs,thetaobs,kappa_ibw).*eval_kernsmoth(thetaobs2,thetaobs,kappa_ibw)))

Nstrap=4000;
bootstrap=zeros(1,Nstrap);
for ii=1:Nstrap
    thetaobsstrap = thetaobs(randi(size(thetaobs,2),size(thetaobs)));
    thetaobsstrap2 = thetaobs2(randi(size(thetaobs,2),size(thetaobs)));
    bootstrap(ii)=sum(log(eval_kernsmothtwod(thetaobsstrap,thetaobsstrap2,thetaobsstrap,thetaobsstrap2,kappa_ibw))) - sum(log(eval_kernsmoth(thetaobsstrap,thetaobsstrap,kappa_ibw).*eval_kernsmoth(thetaobsstrap2,thetaobsstrap,kappa_ibw)));
end
hist(bootstrap,100)
xlabel 'T(.)'
ylabel 'frequency'
saveas(gca,'samplingdisttheta1theta1.png')

fprintf(1,'p-value is')
sum(bootstrap>T)/Nstrap

fprintf(1,'which indicates that there is a depedency between the two data sets, which is of course true they are identical\n')

return;

